/*
	$Id: BIMClientServer.h,v 1.10 2002/11/29 12:29:09 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once

// IM̃oh
#define kIMBundleIdentifier "org.ccm-software.AquaSKKInputMethod"

// ĨAv
#define kBasicServerName "\pAquaSKKServer.app"
#define kCSTR_SKKServerName "AquaSKKServer.app"

// Ĩ|[g
#define kBasicServerPortName "org.ccm-software.AquaSKKServer"

// NCAgIւ̃bZ[W̑MŁAcontent̐擪ɕtwb_B
struct BasicMessageHeader {
    ProcessSerialNumber		fProcessSerialNumber;
};
typedef struct BasicMessageHeader BasicMessageHeader;

// TSMoɎgp\́B
struct OffsetToPosParams {
    long			fRefCon;
    long			fTextOffset;
    ScriptLanguageRecord	fSLRec;
    Boolean			fLeadingEdge;
    OSStatus			fReplyResultCode;
    Point			fReplyPoint;
    Boolean			fReplySLRecSpecified;
    ScriptLanguageRecord	fReplySLRec;
    Boolean			fReplyFontSpecified;
    long			fReplyFont;
    Boolean			fReplyPointSizeSpecified;
    Fixed			fReplyPointSize;
    Boolean			fReplyLineHeightSpecified;
    short			fReplyLineHeight;
    Boolean			fReplyLineAscentSpecified;
    short			fReplyLineAscent;
    Boolean			fReplyTextAngleSpecified;
    Fixed			fReplyTextAngle;
};


typedef SInt32 BasicMessageID;

enum { // NCAgIւ̃bZ[W
    kBasicMessageActivated			= 100,	// SKKANeBuɂȂB
    kBasicMessageDeactivated			= 101,	// SKKANeBułȂȂB
    kBasicMessageHidePalettes			= 102,	// pbgB悤ATSMɎwꂽ
	
	kSKKMessageSearch = 200, // BNǦ`UniChar̔zŗႦ΁u+e vu-͂vB
	// 艼ΐ擪+A-B艼ꍇ͔pXy[Xŋ؂ĂB
	// X|X͗Ⴆ΁uႦ gvuz rv̂悤ɔpXy[Xŋ؂ĂB
	kSKKCreateCandidatesWindow = 201, // Iʂ\B
	// NǦ`
	// +0	\ׂxW(QuickDrawW)	t2oCg
	// +2	\ׂyW(QuickDrawW)	t2oCg
	// +4	(q)						UniCharz
	// :u   gv̂悤Ɋ̕𔼊pXy[Xŋ؂ĕׂ́B
	//
	// X|X
	// +0	IID				2oCg
	// +2	1t[ɕ\̐	2oCg
	// +4	t[					2oCg
	// v6oCgB
	kSKKCandidatesWindowNext = 202, // w肵IʂփXN[BNG2oCǧIIDBX|XB
	kSKKCandidatesWindowPrev = 203, // OփXN[BNextƓB
	kSKKCloseCandidatesWindow = 204, // BNextƓB
	kSKKRegisterThisToUserDic = 205, // [U[ւ̓o^BNǦ`UniChar̔zŁA
	// Ⴆ΁u+e  vu-͂ zvƂȂĂBX|X͖B
	kSKKRemoveThisFromUserDic = 206, // [U[폜BNǦ`kSKKRegisterThisToUserDicƓB
	
	kSKKShowAboutBox = 300, // AboutBox\BX|X͖B
	kSKKShowPreferencesBox = 301, // ݒEChE\BX|X͖B
	kSKKShowWordRegistrationBox = 302, // Po^EChE\BX|X͖B
	
    kSKKFetchCompletions = 400, // ⊮̌BNǦ`UniChar̔zŁA
	// Ⴆ΁uفvBX|X́uق قv̂悤ɔpXy[Xŋ؂ꂽõXgB
};

enum {
    kBasicMessageIsSkkEggLikeNewline = 500,	// 
};

