/*
	$Id: CandidatesView.h,v 1.4 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import <AppKit/AppKit.h>

@class CandidatesWindowController;

@interface CandidatesView : NSView
{
	NSArray* candidates;
	
	NSFont *font;
	float margin_x,margin_y; // EChE㉺E̗]
	float interval_x,interval_y; // ⓯m̉yяc̊Ԋu
	// interval_y = margin_y * 2łKvBȂƏcɃXN[oȂB
	
	float item_width,item_height; // ẻƏc
	float remaining_width; // [cn]\̉
	
	unsigned cands_per_frame; // 1t[̌̐Bʏ7B
	unsigned n_frames; // t[Bceil(̐ / 7);
	unsigned current_frame; // ݂̃t[B0IWB
	unsigned frames_rendered; // 擪牽t[Ƀ_Oς݂B
	int offset; // ʒûBXN[Aj[VpB
	
	float offscreen_width,offscreen_height;
	NSImage *offscreen;
}
- initWithCandidates:(NSArray*)cands;

- (void)showNextFrame;
- (void)showPrevFrame;
- (unsigned)getCandidatesPerFrame;
- (unsigned)getNumOfFrames;
@end
