/*
	$Id: ServerMessageReceiver.h,v 1.3 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <exception>
#include "CppMessagePortServer.h"

/*
	NCAg̃bZ[W󂯎NXłB
	
	̃NX̃IuWFNg͈쐬Ȃ̂Singletonł邩m܂񂪁A
	CFRunLoopRefKvłIuWFNg擾\bhpӂĂȂ̂
	SingletonƂĂ͕ό`Ă܂B
*/

class ServerMessageReceiver : public CppMessagePortServer
{
	protected:
		ServerMessageReceiver(CFRunLoopRef runloop_to_install) throw(std::exception);
		ServerMessageReceiver(const CppCFString& port_name,CFRunLoopRef runloop_to_install) throw(std::exception); // ̃RXgN^͎gp֎~Bstd::exception𓊂B
		virtual ~ServerMessageReceiver();
		
		virtual CppCFData messageReceived(SInt32 message_id,const CppCFData& attachment);
		
		virtual CppCFData searchWord(const CppCFData& attachment);
		virtual CppCFData createCandidatesWindow(const CppCFData& attachment);
		virtual void candidatesWindowNext(const CppCFData& attachment);
		virtual void candidatesWindowPrev(const CppCFData& attachment);
		virtual void closeCandidatesWindow(const CppCFData& attachment);
		virtual void registerThisToUserDic(const CppCFData& attachment);
		virtual void removeThisFromUserDic(const CppCFData& attachment);
		virtual void showAboutBox();
		virtual void showPreferencesBox();
		virtual CppCFData eggLikeNewline();
		virtual CppCFData fetchCompletions(const CppCFData& attachment);
		
	public:
		static void start(CFRunLoopRef runloop_to_install);
};