/*
	$Id: ChildInputMode.h,v 1.4 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include "InputMode.h"


class ChildInputMode : public InputMode
{
	protected:
		class ParentInputMode* parent;
		
	public:
		ChildInputMode(ParentInputMode& parent);
		virtual ~ChildInputMode() {}
		
		virtual ParentInputMode& getParent() const;
		
		// ͂ł͓͂L[ɗ߂ďo͂sA
		// ̃L[݋ɂȂĂ邩ǂԂB
		virtual bool isQueueEmpty() const { return true; }
		
		// CvbgGAXV鎞ɌĂ΂B
		// Ԃꂽ񂪃CvbgGAɐݒ肳B
		// \Ȃ͋󕶎ԂB
		virtual CppCFString getStringToDisplay() = 0;
		
		// m肳鎞ɌĂ΂B
		// Ԃꂽ񂪊m肳B
		// m肵Ȃ͋󕶎ԂB
		virtual CppCFString getStringToFix() = 0;
};
