/*
	$Id: CppMessagePortServer.h,v 1.2 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <exception>
#include "CppCFString.h"
#include "CppCFData.h"

/*
	CppMessagePortServeŕACFMessagePortRefgT[o[łB
	Templatep^[钊ۃNXłB
	
	̃NX͔j鎞ɁARunLoop玩gACXg[܂B
*/

class CppMessagePortServer
{
	protected:
		CFRunLoopRef runloop;
		CFRunLoopSourceRef runloop_source;
		
		static CFDataRef callback_message_received(CFMessagePortRef server_port,SInt32 message_id,
											  CFDataRef attachment,void *context_info);
		virtual CppCFData messageReceived(SInt32 message_id,const CppCFData& attachment) = 0;
		
	public:
		CppMessagePortServer(const CppCFString& port_name,CFRunLoopRef runloop_to_install) throw(std::exception);
		virtual ~CppMessagePortServer();
};