/*
	$Id: ZenAscInputMode.h,v 1.6 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include "ChildInputMode.h"
#include "CppCFString.h"

class ZenAscInputMode : public ChildInputMode
{
	public:
		ZenAscInputMode(class ParentInputMode& parent);
		virtual ~ZenAscInputMode() {}
		
		virtual bool handleInput(unsigned char inputChar);
		virtual bool handleBackSpace();
		virtual bool handleReturn();
		virtual bool handleArrow(int kind);
		virtual void terminate() {};
		virtual CppCFString getStringToDisplay();
		virtual CppCFString getStringToFix();
		
		static CppCFString convert(const CppCFString& from); // pSpɕϊ

	protected:
		CppCFString buffer;
};
